/***********************************
  Therconsult srl.
  copyright 2000 Arturo Tamayo Daza
  Email thee2d2@ceibo.entenet.bo
  Telfono 0591-2-421368 
           0591-2-751932
  Av. Snchez Lima # 2195
  La Paz - Bolivia
  06/Julio/2001

  Gracias a: Ramn Avendao por el primer ejemplo 
             que sin su colaboracin no habra sido posible este
             trabajo,
             De igual manera para Hernn Diego Ceccarelli por su trabajo 
             en el twbrowse que ha posibilitado este desarrollo.

NOTA:
     La Clase Twbrowse con las discupas a Hernn, se ha modificado
     incrementando una

       DATA tamayo INIT 0

      Esto para que pueda recoger la tecla que se ha ejecutado, 
      de tal manera que se pueda manejar el grafico del cronograma 
      ademas con las teclas, (ver la funcin MCambio(,,,) )
           Pageup
           PageDown
           End
           Home, etc...
***********************************/
#include "FiveWin.ch"
#include "Gantt.ch"
#include "Splitter.ch"
#include "Folder.ch"

#define TA_LEFT            0
#define TA_RIGHT           2
#define TA_CENTER          6
#define HSTEP             10
#define VSTEP             14

static oWndGant
Static Nrecno
Static nFlec:=.t.
static oMain
Static nHoriz:=0
Static ograficos,odias
Static nvertic:=0
Static nTipo:=1
Static oLbx
Static dFecIni
Static nRowAnt:=1
Static Opera:=.t.
//----------------------------------------------------------------------------//
function Gantt()
   local obarGant,oFlec,oIco
   local cTitle := "QuarK - Cronograma Gantt"
   local cText,ofont,ofont2,oFont3,cPos
   local oPen1, oPen2, oPen3,oPen4,oPen5,oPen6,oPen7
   Local osay,oSay1,wDescri
   Local wDiaLab:={.f.,.t.,.t.,.t.,.t.,.t.,.f.}
   Local lExit:=.f.,nWinRow:=0,nWinCol
   Local oSplit,oSplit1
   local dfecAnt
   Local dFecha
   Local wClrBack
   SET DATE BRITISH
   SET CENTURY ON
   SET DELETE ON
   SET CONFIRM ON
   SET EPOCH TO 1960
   SET LOOK3D ON

   SELECT 1
   USE PRESED.dbf ALIAS PRESGAN
   INDEX ON str(PresGan->CORREL,4,0)+str(PresGan->CorPre,4,0) TO BORRE
   SELECT 2 
   USE ACTIVIDAD.DBF ALIAS ACTIVPROG
   nrecno:=ActivProg->(LastRec())
   dFecIni:=ctod('01/09/2000')
   ActivProg->(dbgotop())
   dfecIni:=ActivProg->fecINi
   Do while ActivProg->(!eof())
      if dFecIni > ActivProg->fecIni
         dfecIni:=ActivProg->fecINi
      endif
      ActivProg->(Dbskip())
   enddo
   ActivProg->(dbgotop())
   wDescri:="PERIFERICA POTOSI"
   dfecAnt:=dFecIni 
   dfecha:=dFecIni 
   if dow(dfecha)>1
      do while dow(dfecha)>1
         dfecha--
      enddo
   endif
   if dow(dfecha)=1
      dfecha++
   endif
   wClrBack:=GetSysColor(15)


   DEFINE PEN oPen2 WIDTH 8 COLOR RGB(223,223,223) STYLE 2  //rectangulo feriado    //RGB(230,230,230) STYLE 2
   DEFINE PEN oPen1 WIDTH 1 COLOR CLR_WHITE STYLE 0 //linea blanca
   DEFINE PEN oPen3 WIDTH 1 COLOR CLR_GRAY STYLE 0 //Lineas de division

   DEFINE BRUSH oPen4 COLOR CLR_HBLUE  //rectangulo azul
   DEFINE BRUSH oPen5 COLOR CLR_HRED  //rectangulo rojo

   DEFINE PEN oPen6 WIDTH 1 COLOR CLR_HBLUE STYLE 0 //flechas
   DEFINE PEN oPen7 WIDTH 1 COLOR CLR_HRED STYLE 0 //flechas

   DEFINE FONT oFont3 NAME "Ms Sans Serif" SIZE 0,-12 BOLD
   DEFINE FONT oFont2 NAME "Ms Sans Serif" SIZE 0,-12 
   DEFINE FONT oFont NAME "Ms Sans Serif" SIZE 0,-9 

   nwinRow:=(MaxRow()-8)*16
   nWinCol:=(Maxcol()-2)*8

   DEFINE ICON oIco RESOURCE "QUARKI"

   DEFINE WINDOW oWndGant FROM 16, 8 TO nWinRow , nWinCol PIXEL ; 
      TITLE cTitle 

   DEFINE BUTTONBAR obarGant 3D OF oWndGant SIZE 26, 26 

     DEFINE BUTTON OF obarGant  ;
       ACTION editact(odias,ofont,@nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,nTipo,nvertic,olbx,wDiaLab) ;
       RESOURCE "OPTION";
       NOBORDER ;
       TOOLTIP "Editar Actividad"

     DEFINE BUTTON OF obarGant ;
       RESOURCE "CALEND";
       NOBORDER ;
       TOOLTIP "Definir Calendario"


     DEFINE BUTTON OF obarGant GROUP ;
       ACTION aZoom(odias,ofont,@nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,@dFecha,@nTipo,.f.,@nvertic,olbx) ;
       RESOURCE "ZMAS";
       NOBORDER ;
       TOOLTIP "Ampliar Escala"

     DEFINE BUTTON OF obarGant ;
       ACTION (aZoom(odias,ofont,@nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,@dFecha,@nTipo,.t.,@nvertic,olbx),olbx:setfocus()) ;
       RESOURCE "ZMEN";
       NOBORDER ;
       TOOLTIP "Disminuir Escala"

     DEFINE BUTTON OF obarGant GROUP ;
       ACTION ( nVertic :=0 ,;  //-=( 0-oGraficos:oVScroll:GetPos() )*VSTEP, ;
                oGraficos:oVScroll:SetPos(0), ;
                VScroll(ograficos,Olbx,@nVertic,.t.),olbx:gotop(),olbx:setfocus() ) ;
       RESOURCE "INICIO";
       NOBORDER ;
       TOOLTIP "Al Principio"

     DEFINE BUTTON OF obarGant ;
       ACTION ( oGraficos:oVScroll:PageUp(),olbx:setfocus() ); 
       RESOURCE "ANTER";
       NOBORDER ;
       TOOLTIP OemToAnsi("Pgina Arriba")

     DEFINE BUTTON OF obarGant ;
       ACTION ( oGraficos:oVScroll:PageDown(),olbx:Setfocus() ); 
       RESOURCE "SEGUI";
       NOBORDER ;
       TOOLTIP OemToAnsi("Pgina Abajo")

     DEFINE BUTTON OF obarGant ;
       ACTION ( cPos:= ( oGraficos:oVScroll:Getpos() ),;
                oGraficos:oVScroll:goBottom() ,;
                nVertic -= ( oGraficos:oVScroll:GetPos()-cpos )*VSTEP, ;
                VScroll(ograficos,Olbx,@nVertic,.t.),Olbx:gobottom(),olbx:setfocus() );
       RESOURCE "FINAL";
       NOBORDER ;
       TOOLTIP "Al Final"

     DEFINE BUTTON oFlec OF obarGant GROUP ;
       ACTION (if( nflec, nflec:=.f.,nflec:=.t.),oGraficos:refresh()) ;
       RESOURCE "PRES";
       NOBORDER ;
       TOOLTIP "Mostrar Precedencia"

     DEFINE BUTTON OF obarGant GROUP ;
       ACTION ( CalGantt(wdialab,@dFecIni,@dFecAnt,.t.,.t.),ograficos:refresh() ) ;
       RESOURCE "REFRE";
       NOBORDER ;
       TOOLTIP "Refrescar"

     DEFINE BUTTON OF obarGant GROUP ;
       ACTION oWndGant:end();
       RESOURCE "SALIR";
       NOBORDER ;
       TOOLTIP "Salir"

   twbrowse():lVscroll:=.f. //importante para desactivar el scroll vertical del listbox

   @ 26,0 LISTBOX oLbx FIELDS  xPadl(str(ActivProg->Correl,4,0),30),;
              ActivProg->Descri,;
              xPadl(str(ActivProg->DiaPro,8,2),60),;
              dtoc(ActivProg->FecIni),;
              dtoc(ActivProg->FecFin),;
              xPadl(str(ActivProg->Prodia,10,2),80),;
              xPadl(str(ActivProg->VolObr,10,2),80),;
              ActivProg->Unidad;
      ALIAS "ActivProg" ; 
      HEADERS "No"+CRLF+OemToAnsi("Item" ),; // CRLF para escribir en doble linea la cabecera soslo funciona con centrado
              OemToAnsi( "Descripcin")+CRLF+"de la Actividad",;
              OemToAnsi('Das')+CRLF+"Requeridos",;
              "Fecha de"+CRLF+OemToAnsi('Inicio'),;
              "Fecha de"+CRLF+OemToAnsi('Conclusin'),;
              OemToAnsi("Producin" )+CRLF+"Horaria",;
              OemToAnsi('Cantidad')+CRLF+"de Obra", ;
              OemToAnsi( "Unidad");
      FIELDSIZES 30,160,60,64,64,65,65,60 ;
      ON DBLCLICK editact(odias,ofont,@nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,nTipo,nvertic,olbx,wDiaLab) ;
      SIZE 250.1,nWinRow-68 PIXEL OF oWndGant FONT oFont2

      olbx:lCellstyle:=.t.
      olbx:nFreeze:=1
      Olbx:nlineStyle:=3
      Olbx:aHJustify:={2,2,2,2,2,2}
      olbx:bTextColor:={ |nRow,nCol| if(nCol==1,CLR_BLACK,)}
      olbx:bBkColor:={ |nRow,nCol| if(nCol==1,wClrBack,)} 
      olbx:nHeaderHeight:=33  //permite definir el ancho de la cabecera del browse
      oLbx:bChange:={|| Mcambio(olbx,ograficos,@nVertic)}

   @ 26,253 GANTT oDias WINDOW oWndGant ;
            SIZE nwincol-270,38 ; 
            BORDER ;
            COLORS CLR_BLACK, wclrBack //CLR_HGRAY      

   oDias:bPainted        := {|| Dias(odias,ofont,nHoriz,osplit,wDiaLab,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,nTipo,nVertic) }

   @ 60,253 GANTT oGraficos WINDOW oWndGant ;
            SIZE nwincol-270,nWinRow-102 ;
            BORDER ;
            VSCROLL ;
            HSCROLL ;
            BOXLIS oLbx;  //definir el objeto del listboz que maneja el browse
            ON CHANGE editFec(odias,ofont,@nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,nTipo,nvertic,olbx,wDiaLab) ; //para modificaciones de ancho de la barra
            ON PRESED editPre(odias,ofont,@nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,nTipo,nvertic,olbx,wDiaLab) ; //para encadenamientos entre barras
            COLORS CLR_BLACK, CLR_WHITE

   ograficos:bPainted    := {|| Graficos(@oGraficos,osplit,wDiaLab,oSplit1,nhoriz,oPen1,oPen3,oPen4,oPen5,oPen2,oPen6,oPen7,dFecIni,dFecha,nTipo,@nVertic,oFont) }


   @ 60,253  SPLITTER oSplit1 WINDOW  oWndGant ;
             HORIZONTAL ;
             PREVIOUS CONTROLS odIAS ;
             HINDS CONTROLS oGraficos ;
             SIZE nWinCol-270,0 PIXEL 

   @ 26, 250  SPLITTER oSplit ;
              VERTICAL ;
              PREVIOUS CONTROLS oLbx ;
              HINDS CONTROLS oGraficos,oDias,oSplit1 ;
              SIZE 2, 400 PIXEL ;
              OF oWndGant ;
              _3DLOOK ;
              LEFT MARGIN 100 ;
              RIGHT MARGIN 140 

   oSplit1:lStatic := .t. 
   oSplit1:Hide()

   DEFINE SCROLLBAR oGraficos:oHScroll OF oGraficos ;
          HORIZONTAL ;
          RANGE 0, 3600/HSTEP ;
          PAGESTEP 5; 
          ON UP ( nHoriz += HSTEP, HScroll2(odias,ofont,@nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,ntipo) ) ;
          ON DOWN ( nHoriz -= HSTEP, HScroll2(odias,ofont,@nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,nTipo)  ) ;
          ON PAGEUP ( nHoriz += 5*HSTEP, HScroll2(odias,ofont,@nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,ntipo)  ) ;
          ON PAGEDOWN ( nHoriz -= 5*HSTEP, HScroll2(odias,ofont,@nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,ntipo)  ) ; 
          ON THUMBPOS ( nHoriz -= ( nPos-oGraficos:oHScroll:GetPos() )*HSTEP, ;
                        oGraficos:oHScroll:SetPos(nPos), ;
                        HScroll2(odias,ofont,@nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,ntipo)  ) 

   DEFINE SCROLLBAR oGraficos:oVScroll OF oGraficos ;
          VERTICAL ;
          RANGE 0, (nRecno-olbx:nrowCount()) ; 
          PAGESTEP  10 ;
          ON UP ( nVertic += VSTEP, VScroll(ograficos,Olbx,@nVertic,.t.) ) ;
          ON DOWN ( nVertic -= VSTEP, VScroll(ograficos,Olbx,@nVertic,.t.) ) ;
          ON PAGEUP ( if(nVertic+Olbx:nRowCount()*VSTEP <0 ,nVertic +=olbx:nRowCount()*VSTEP,nVertic:=0 ),;
                      VScroll(ograficos,Olbx,@nVertic,.t.)  ) ;
          ON PAGEDOWN (If( nVertic-Olbx:nRowCount()*VSTEP > (nrecno -oLbx:nRowCount())*(-14),nVertic-=oLbx:nRowCount()*VSTEP,;
                           nvertic:=( nRecno-olbx:nRowCount() )*(-14) ),;
                            VScroll(oGraficos,Olbx,@nVertic,.t.) ) ; 
          ON THUMBPOS ( nVertic -= ( nPos-oGraficos:oVScroll:GetPos() )*VSTEP, ;
                        oGraficos:oVScroll:SetPos(nPos), ;
                        VScroll(ograficos,Olbx,@nVertic,.t.) )


   @ 8, 340 SAY oSay PROMPT "Proyecto:" SIZE 50,15 OF obarGant FONT oFont PIXEL 
   @ 8, 390 SAY oSay1 PROMPT wDescri SIZE 350,16 OF obarGant FONT oFont3 PIXEL  


  SET MESSAGE OF oWndGant TO "Copyright Arturo Tamayo Daza" CENTERED  NOINSET KEYBOARD TIME DATE

  ACTIVATE WINDOW oWndGant ; // MAXIMIZED ;
     ON RESIZE ( osplit:AdjClient() , oSplit1:adjRIGHT() ,;
     oGraficos:oVScroll:SetRANGE(0,nRecno-Olbx:nRowCount()),;
     oGraficos:oVScroll:npgStep:=Olbx:nRowCount() ) ;
     VALID        (oWndGant:oIcon := NIL       ,;
                   oWndGant := NIL             ,;
                   lExit := .T.            ,;
                   .T.)

     DO WHILE !lExit
          SysWait(.1)
     ENDDO
odias:=NIL
oGraficos:=NIL
return nil

//------------------------------------//
STATIC Function Mcambio(Olbx,oGraficos,nvertic)
   local cpos

   opera :=.f.

   do case
      case olbx:tamayo == VK_UP
       if ! Olbx:lHitTop
          if nRowAnt = olbx:nRowpos
              oGraficos:oVScroll:GoUp()
          endif
       endif
      case olbx:tamayo == VK_DOWN
       if ! Olbx:lHitBottom
          if nRowAnt = olbx:nRowpos
            oGraficos:oVScroll:goDown()
          endif
       endif
      case olbx:tamayo == VK_HOME 
              nVertic :=0 
              oGraficos:oVScroll:SetPos(0)
              VScroll(ograficos,Olbx,@nVertic,.f.) 
      case olbx:tamayo == VK_END 
              cPos:= ( oGraficos:oVScroll:Getpos() )
              oGraficos:oVScroll:goBottom() 
              nVertic -= ( oGraficos:oVScroll:GetPos()-cpos )*VSTEP
              VScroll(ograficos,Olbx,@nVertic,.f.)
      case olbx:tamayo == VK_PRIOR 
           if GetKeyState( VK_CONTROL )
              nVertic -=( 0-oGraficos:oVScroll:GetPos() )*VSTEP
              oGraficos:oVScroll:SetPos(0)
              VScroll(ograficos,Olbx,@nVertic,.f.) 
           else
            oGraficos:oVScroll:Pageup()
           endif
      case olbx:tamayo == VK_NEXT 
           if GetKeyState( VK_CONTROL )
              cPos:= ( oGraficos:oVScroll:Getpos() )
              oGraficos:oVScroll:goBottom() 
              nVertic -= ( oGraficos:oVScroll:GetPos()-cpos )*VSTEP
              VScroll(ograficos,Olbx,@nVertic,.t.)
           else
            oGraficos:oVScroll:PageDown()
           endif
   endcase
   nRowAnt := olbx:nRowpos
   opera:=.t.
   olbx:tamayo:=0
Return NIL

//----------------------------------------------------------------------------//
FUNCTION Dias(odias,ofont,nhoriz,osplit,wDiaLab,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dfecha,nTipo,nVertic)
  LOCAL nDias :=0,nFacMes:=1
  LOCAL mDia:={"D","L","M","M","J","V","S"}
  Local ndia
  LOCAL nColumna :=-1
  LOCAL dDia,wMesA:=0,wAno:=0
  LOCAL lDomingo, cMes, cAno,cdia:=1
  Local aMeses:={"Ene","Feb","Mar","Abr","May","Jun","Jul","Ago","Sep","Oct","Nov","Dic"}
  oDias:Line( 16, 0, 16, oSplit1:nLong )
  oDias:Line( 32, 0, 32, oSplit1:nLong )
  oDias:Line( 0, nColumna, 32, nColumna )
  oDias:Line( 0, nColumna+2, 32, nColumna+2,oPen1 )
  oDias:Line( 0, 0, 0, oSplit1:nLong,oPen1 )

do case
  Case ntipo=1
     nDias := INT( ABS( nHoriz / 14 ) )
     nColumna := nHoriz + nDias * 14 - 1
     dDia := dFecha + nDias 
     cMes := aMeses[ MONTH( dDia ) ]
     DO WHILE nColumna < oSplit1:nLong
       nDia := DAY( dDia )
        ldomingo := DOW( dDia )==1
        if !wDiaLab[DOW( dDia )] 
           oDias:Say( 18, nColumna+7, Mdia[dow(dDia)], CLR_HRED, , oFont, .T., .T., TA_CENTER,odias )
        ELSE
           oDias:Say( 18, nColumna+7, Mdia[dow(dDia)], CLR_BLUE,, oFont, .T., .T., TA_CENTER,odias )
        endif
        IF lDomingo  
           oDias:Line( 0, nColumna+14, 32, nColumna+14 )
           oDias:Line( 0, nColumna+16, 32, nColumna+16,oPen1 )
        ENDIF   
        if dow(ddia) ==2
           cdia:=day(ddia)
           cMes := aMeses[ MONTH( dDia ) ]
        endif
        if dow(ddia) ==5
           cAno := RIGHT( STR( YEAR( dDia ) ), 4 )
           oDias:Say( 2, nColumna," "+str(cdia,2)+'/'+cMes+"/"+cAno+" ",CLR_BLACK , , oFont, .T., .T., TA_CENTER ,odias)
         endif
         dDia++
         nColumna += 14
         IF !lDomingo  
            oDias:Line( 16, nColumna, 32, nColumna )
         endif
     ENDDO   
  case ntipo = 2
     nDias := INT( ABS( nHoriz / 8 ) )
     nColumna := nHoriz + nDias * 8 - 1
     dDia := dFecha + nDias 
     wMesA :=  MONTH( dDia )
     DO WHILE nColumna < oSplit1:nLong
        nDia := DAY( dDia )
        if ndia = 1
           oDias:Line(0, nColumna, 16, nColumna ) 
        endif
        IF DOW( dDia )==2
           oDias:Say( 18, nColumna+28, RIGHT(str(nDia),2), CLR_BLUE, , oFont, .T., .T., TA_CENTER )
           oDias:Line(16, nColumna, 32, nColumna )
        ENDIF
        if ndia = 15
           cMes := aMeses[ MONTH( dDia ) ]
           cAno := RIGHT( STR( YEAR( dDia ) ), 4 )
           oDias:Say( 2, nColumna, cMes+"/"+cAno,CLR_BLACK , , oFont, .T., .T., TA_CENTER )
         endif
         dDia++
         nColumna += 8
     ENDDO   
  case ntipo = 3
     nDias := INT( ABS( nHoriz / 2 ) )
     nColumna := nHoriz + INT(ABS(nDias * 2)) - 1
     dDia := dFecha + nDias 
     wAno :=  YEAR( dDia )
     DO WHILE nColumna < (oSplit1:nLong)
        nDia := DAY( dDia )
        if wAno<Year(ddia)
           oDias:Line( 0, nColumna, 32, nColumna )
           oDias:Line( 0, nColumna+2, 32, nColumna+2,oPen1 )
           wAno :=  YEAR( dDia )
           wMesA := 0
        endif
        IF DAY( dDia )== 1
           nfacmes:=0
           do while Month(ddia) = month(ddia+nFacMes)
             nFacMes++ 
           enddo
           cMes := aMeses[ MONTH( dDia ) ]
           oDias:Say( 18, nColumna+nfacMes,Cmes, CLR_BLUE, , oFont, .T., .T., TA_CENTER )
           oDias:Line(16, nColumna, 32, nColumna )
        ENDIF
        if MONTH(ddia) = 7 .and. wMesA != Month(ddia)
           cAno := RIGHT( STR( YEAR( dDia ) ), 4 )
           oDias:Say( 2, nColumna+14, cAno,CLR_BLACK , , oFont, .T., .T., TA_LEFT )
           wMesA :=  MONTH( dDia )
        endif
        nColumna += 2 
        dDia++
     ENDDO   
endcase
RETURN odias 

//--------------------------------------------------------------//
FUNCTION Graficos(oGraficos,osplit,wDiaLab,osplit1,nhoriz,oPen1,oPen3,oPen4,oPen5,oPen2,oPen6,oPen7,dFecIni,dFecha,nTipo,nVertic,ofont)

  LOCAL nReg := ActivProg->(RECNO())
  Local nOldRec:=ActivProg->(recno())
  LOCAL nLinea := 0
  LOCAL nFacMes:=1
  LOCAL nColumnaInicio, nColumnaFinal
  Local dDia,i:=0
  Local ndia,nreco:=0
  LOCAL nDias := 0
  LOCAL nColumna := 0
  LOCAL wMesA:=0,wAno:=0
  Local Openmio, wCorCri:=0
  Local nfac:=14
  do case
     case ntipo=1
        nDias := INT( ABS( nHoriz / 14 ) )
        nColumna := nHoriz + nDias * 14 
        dDia := dFecha + nDias 
        DO WHILE nColumna < oSplit1:nLong
           nDia := DAY( dDia )
           if !wDiaLab[DOW( dDia )] // = 1
              oGraficos:Rectang( 0, nColumna+4, osplit:nLong, nColumna+12,oPen2 )
           endif
           if DOW( dDia ) = 1
              oGraficos:Line( 0, nColumna+14, oSplit:nLong, nColumna+14, oPen3 )
           ENDIF   
           if ddia=dFecIni
              oGraficos:Line( 0, nColumna,oSplit:nLong, nColumna,oPen3 )
           endif
           dDia++
           nColumna += 14.1
        enddo
        nfac:=14
     case ntipo=2 
        nDias := INT( ABS( nHoriz / 8 ) )
        nColumna := nHoriz + nDias * 8 - 1
        dDia := dFecha + nDias 
        wMesA :=  MONTH( dDia )
        DO WHILE nColumna < oSplit1:nLong
           IF DOW( dDia )==2
              oGraficos:Line(0, nColumna, oSplit:nlong, nColumna,oPen3 )
           ENDIF
           if ddia=dFecIni
              dow(ddia)
              oGraficos:Line( 0, nColumna,oSplit:nLong, nColumna )
           endif
           nColumna += 8
           dDia++
        enddo
        nfac:=8
     case ntipo=3 
        nDias := INT( ABS( nHoriz /2 ) )
        nColumna := nHoriz + INT(ABS(nDias *2)) - 1
        dDia := dFecha + nDias 
        wAno :=  YEAR( dDia )
        DO WHILE nColumna < oSplit1:nLong
           nDia := DAY( dDia )
           if ndia=16
              oGraficos:Line( 0, nColumna,oSplit:nLong, nColumna,oPen3 )
           endif
           if ddia=dFecIni
              oGraficos:Line( 0, nColumna,oSplit:nLong, nColumna,oPen3 )
           endif
           IF DAY( dDia )== 1
              nfacmes:=0
              do while Month(ddia) = month(ddia+nFacMes)
                 nFacMes++
              enddo
              oGraficos:Line(0, nColumna,oSplit:nLong, nColumna ) //,oPen3 )
              if wAno<Year(ddia)
                 oGraficos:Line( 0, nColumna, oSplit:nLong, nColumna )
                 wAno :=  YEAR( dDia )
              endif
           ENDIF
           nColumna += 2 
           dDia++
       enddo
      nfac:=2
   endcase

        ActivProg->(dbGOTOP())
        DO WHILE ActivProg->(!EOF()) //.and. nreco<olbx:nRowCount()
           wCorCri:=0
           nColumnaInicio :=( ActivProg->FECINI - dFecha )  * nfac
           nColumnaFinal := (  ActivProg->FECFIN - dFecha + 1 ) * nfac 
           if ActivProg->TipAct=1
              oGraficos:FillRect( {nLinea+nVertic+4, nColumnaInicio+nHoriz, nLinea+nVertic+10, nColumnaFinal+nHoriz},oPen5,ActivProg->(Recno()) ) 
              wCorCri:=ActivProg->ItePre
           else
              oGraficos:FillRect( {nLinea+nVertic+4, nColumnaInicio+nHoriz, nLinea+nVertic+10, nColumnaFinal+nHoriz},oPen4,ActivProg->(Recno()) )
           endif
           oGraficos:Say( nLinea+nvertic, nColumnaFinal+nHoriz+7, Alltrim(ActivProg->refere), CLR_BLACK, , oFont, .T., .T., TA_LEFT )
           if nFlec
              aFlecha(wCorcri,oPen6,Open7,@oGraficos,nVertic,nHoriz,nColumnaInicio,dfecha,nfac)
           endif
           ActivProg->(dbSKIP())
           nLinea += 14
        ENDDO
        ActivProg->(dbGOTO( nReg))
RETURN oGraficos 
//---------------------------------------------//
FUNCTION HScroll2(odias,ofont,nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,ntipo) 

  LOCAL hWnd 
  LOCAL aRect 
  STATIC nH2 := 0

  IF nHoriz<-3600 
      nhoriz:=-3600
  endif

  IF  nHoriz>0
      nhoriz:=0
  endif


  hWnd := oGraficos:hWnd
  aRect := GetClientRect( hWnd ) 
  ScrollWindow( hWnd ,nHoriz-nH2,0, aRect, aRect )

 
  hWnd := oDias:hWnd
  aRect := GetClientRect( hWnd ) 
  ScrollWindow( hWnd , nHoriz-nH2, 0,  aRect, aRect )


  ograficos:refresh()
  oDias:refresh()

  nH2 := nHoriz
  
RETURN nil
//------------------------------------------------------------------//
Static Function aZoom(odias,ofont,nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,ntipo,op,nVertic,olbx)
   if op
      if ntipo>=1 .and. nTipo <3
         nTipo++
      else
         return NIL
      endif
   else
      if Ntipo>1  .and. Ntipo <=3
         ntipo--
      else
         return NIL
      endif
   endif  
   CambEscala(NTIPO,dFecIni,@dfecha)
   odias:refresh(.t.)
   oGraficos:refresh(.t.)
Return NIL
//--------------------------------------------//
FUNCTION VScroll(oGraficos,Olbx,nVertic,op)
  LOCAL hWnd 
  LOCAL aRect 
  Local Ncor:=0 
  STATIC nV := 0

  nCOR:= (nRecno-Olbx:nRowCount())*14

  IF nVertic<-ncor 
     nVertic := -ncor
  ENDIF   
  IF nVertic>0
     nVertic := 0
  ENDIF   

  if op .and. opera //olbx:HposBottom .and. olbx:hposTop
     ActivProg->(dbskip((nv-nvertic)/14))
     Olbx:refresh(.f.)
  endif

  hWnd := oGraficos:hWnd
  aRect := GetClientRect( hWnd ) 
  ScrollWindow( hWnd, 0, nVertic-nV, aRect, aRect )

  nV := nVertic

RETURN nil

//-----------------------------------------//
Static Function CambEscala(NTIPO,dFecIni,dfecha)
   do case
      case ntipo =1  //dias
         dfecha:=dFecIni 
         if dow(dfecha)>1
            do while dow(dfecha)>1
               dfecha--
            enddo
         endif
         if dow(dfecha)=1
            dfecha++
         endif
      case ntipo=2 //semanas
         dfecha:=Ctod('01/'+str(Month(dFecIni),2)+'/'+str(Year(dFecIni),4))
         if dow(dfecha)!=2
            do while dow(dfecha)!=2
               dfecha++
            enddo
         endif
         if dfecha > dFecIni
            dfecha --
            do while dow(dfecha)!=2
               dfecha--
            enddo
         endif
      case ntipo=3 //meses
        if Month(dFecIni)<=6
             dfecha:=Ctod('01/01/'+str(Year(dFecIni),4))
         else
             dfecha:=Ctod('01/07/'+str(Year(dFecIni),4))
         endif
   endcase
Return NIL

//----------------------//
Static Function editact(odias,ofont,nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,nTipo,nvertic,olbx,wDiaLab) 
Local odlg,oFld,lsave:=.f.,oProuni,Olbp
Local wCorrel,wDescri,wVolObr,wUnidad,wItem
Local oCorrel,oDescri,oVolObr,oUnidad
local wFecini,wFecfin
local oFecini,oFecfin
local oBFecini,oBFecfin
Local wProdia,wDiapro,wNumCua,wRefere
Local oProdia,oDiapro,oNumCua,oRefere

   wCorrel:=ActivProg->Correl
   wItem  :=ActivProg->Item
   wDescri:=ActivProg->Descri
   wUnidad:=ActivProg->Unidad
   wVolObr:=ActivProg->VolObr
   wProdia:=ActivProg->Prodia
   wFecIni:=ActivProg->Fecini
   wFecFin:=ActivProg->FecFin
   wDiaPro:=ActivProg->DiaPro
   wRefere:=ActivProg->Refere
   if wdiapro>0 .and. wProdia >0
      wNUmcua:=wVolObr/(wProdia*8*wdiapro)
   else
      wNumCua:=0
   endif
   DEFINE DIALOG oDlg RESOURCE "GANLOG_1" TITLE OemtoAnsi("Datos de Programacin de la Actividad")
   
   REDEFINE FOLDER oFld ID 101 OF oDlg ;
   PROMPT "&Generales", "&Precedentes" ;
   DIALOGS "GANLOG_3","GANLOG_2"  //;


      REDEFINE GET oCorrel VAR wCorrel ID 101  OF oFld:aDialogs[ 1 ] PICTURE "9999" when .f.
      REDEFINE GET oDescri VAR wDescri ID 102  OF oFld:aDialogs[ 1 ] When .f. 
      REDEFINE GET oVolObr VAR wVolObr ID 103  OF oFld:aDialogs[ 1 ] PICTURE "99,999,999.99" when .f.
      REDEFINE GET oUnidad VAR wUnidad ID 104  OF oFld:aDialogs[ 1 ] when .f.
      REDEFINE GET oProdia VAR wprodia ID 105  OF oFld:aDialogs[ 1 ] PICTURE "999,999.99" VALID FvfecGantt(wFecIni,@wFecFin,wDiapro,@wNumCua,wProdia,wDiaLab,dFecIni,wVolObr,;
                                                                                                           oFecIni,oFecFin,oDiapro,oNumCua,oProdia,4)
      REDEFINE SAY oProUni VAR allTrim(wUnidad)+'/HR' ID 111  OF oFld:aDialogs[ 1 ]

      REDEFINE GET oFecini VAR wFecIni ID 106  OF oFld:aDialogs[ 1 ] VALID FvfecGantt(@wFecIni,@wFecFin,wDiapro,wNumCua,wProdia,wDiaLab,dFecIni,wVolObr,;
                                                                                      oFecIni,oFecFin,oDiapro,oNumCua,oProdia,1)
      REDEFINE GET oFecFin VAR wFecFin ID 107  OF oFld:aDialogs[ 1 ] When .f.
      REDEFINE GET oDiaPro VAR wDiaPro ID 108  OF oFld:aDialogs[ 1 ] PICTURE "9,999.99" VALID FvfecGantt(wFecIni,@wFecFin,wDiapro,@wNumCua,wProdia,wDiaLab,dFecIni,wVolObr,;
                                                                                                         oFecIni,oFecFin,oDiapro,oNumCua,oProdia,2)
      REDEFINE GET oNumCua VAR wNumCua ID 109  OF oFld:aDialogs[ 1 ] PICTURE "9,999.99" VALID FvfecGantt(wFecIni,@wFecFin,@wDiapro,wNumCua,wProdia,wDiaLab,dFecIni,wVolObr,;
                                                                                                         oFecIni,oFecFin,oDiapro,oNumCua,oProdia,3)
      REDEFINE GET oRefere VAR wRefere ID 110  OF oFld:aDialogs[ 1 ] 

      Presgan->(dbGotop())

      REDEFINE LISTBOX oLbP;
      FIELDS  xPadl(str(PresGan->CorPre,4,0),40),;
              PresGan->desPre ;
      ID 9101 OF oFld:aDialogs[ 2 ] ;
      ALIAS "PresGan" ;
      HEADERS  OemToAnsi("Item" ),OemToAnsi( "Descripcin") ;
      SELECT str(PresGan->Correl,4,0) FOR str(wCorrel,4,0) to str(wCorrel,4,0) ;
      FIELDSIZES 40,300 ;
      COLOR CLR_BLACK, RGB(255,255,235) ;
      FONT oFont 

      oLbp:nFreeze:=1
      oLbp:nLineStyle:=10

      REDEFINE BUTTON ID 102 OF oFld:aDialogs[ 2 ]                                  ;
      ACTION fvpresd(1,wCorrel,witem,olbp,.t.)
      REDEFINE BUTTON ID 103 OF oFld:aDialogs[ 2 ]                                  ;
      ACTION fvpresd(2,wCorrel,witem,olbp,.t.)
      REDEFINE BUTTON ID 104 OF oFld:aDialogs[ 2 ]                                  ;
      ACTION fvpresd(3,wCorrel,witem,olbp,.t.)

      REDEFINE BUTTON ID 102 OF oDlg                                  ;
             ACTION (lSave:=.t., odlg:end())

      REDEFINE BUTTON ID 103 OF oDlg                                  ;
             ACTION (lSave:=.f., odlg:end())

     ACTIVATE DIALOG oDlg CENTERED ;
         ON INIT (oBfecIni:= GetBitmap(oFecIni,"GETCAL") )

     if lsave
        ActivProg->(Rlock())
        ActivProg->Fecini:=wfecini
        ActivProg->FecFin:=wFecFin
        ActivProg->DiaPro:=wDiapro
        ActivProg->ProDia:=wProDia
        ActivProg->Refere:=wRefere
        ActivProg->(dbunlock())
        CalGantt(wdialab,@dFecIni,,.f.,.f.)
        olbx:refresh()
        Ograficos:refresh()
    endif
dbcommitall()
return NIL

//---------------------------//
Static Function FvfecGantt(wFecIni,wFecFin,wDiapro,wNumCua,wProdia,wDiaLab,dFecIni,wVolObr,;
                    oFecIni,oFecFin,oDiapro,oNumCua,oProdia,op)
local ndia:=0,i:=0
do case
   Case op=1
        if wFecIni < dFecIni
           MsgInfo(OemToAnsi("La Fecha de Inicio de la Actividad, No puede ser Menor a La Fecha de Inicio del proyecto"),OemtoAnsi("Atencin"))
           Return .f.
        else
          do while !wDiaLab[Dow(wFecIni)]
              wFecIni++
          enddo
          If wdiapro - Int(wDiapro) > 0
            ndia:=Int(wdiapro)
          else
            ndia:=Int(wdiapro)-1
          endif
          wFecFin:=wfecIni
          for i=1 to ndia
              wFecFin++ 
              do while !wDiaLab[Dow(wFecFin)]
                 wFecFin++
              enddo
          next
        endif
        ofecFin:refresh()
        ofecIni:refresh()
   Case op=2
        If wDiapro <=0
           MsgInfo(OemToAnsi("La Cantidad de das No puede ser igual o menor a 0"),OemtoAnsi("Atencin"))
           Return .f.
        else
           If wdiapro - Int(wDiapro) > 0
             ndia:=Int(wdiapro)
           else
             ndia:=Int(wdiapro)-1
           endif
           wFecFin:=wfecIni
           for i=1 to ndia
               wFecFin++ 
               do while !wDiaLab[Dow(wFecFin)]
                  wFecFin++
               enddo
           next
           if wprodia >0 .and. wDiapro>0
              wNumcua:=Round(wVolObr/(wProdia*8*wdiapro),2)
           endif
        endif
        ofecFin:refresh()
        oNumCua:refresh()
   Case op=3
        If wNumCua <=0
           MsgInfo(OemToAnsi("La Cantidad de Cuadrillas No puede ser igual o menor a 0"),OemtoAnsi("Atencin"))
           Return .f.
        else
           if wprodia > 0 .and. wNumCua >0
              wDiaPro:=Round(wVolObr/(wprodia*8*wNumCua),2)
           endif
           If wdiapro - Int(wDiapro) > 0
             ndia:=Int(wdiapro)
           else
             ndia:=Int(wdiapro)-1
           endif
           wFecFin:=wfecIni
           for i=1 to ndia
               wFecFin++ 
               do while !wDiaLab[Dow(wFecFin)]
                  wFecFin++
               enddo
           next
        endif
        ofecFin:refresh()
        oDiaPro:refresh()
   Case op=4
        If wProDia <=0
           MsgInfo(OemToAnsi("La productividad horaria No puede ser igual o menor a 0"),OemtoAnsi("Atencin"))
           Return .f.
        else
           if wprodia >0 .and. wDiapro>0
              wNumcua:=Round(wVolObr/(wProdia*8*wdiapro),2)
          endif
        endif
        oNumCua:refresh()
endcase
return .t.

//------------------------------------------//
Static function fvpresd(op,wCorrel,witem,olbx0,opt)
local odlgU,olbxu,oFontu,lsave:=.f.
local oldrec:=ActivProg->(Recno())
local utemp:=space(30),otemp
do case
 case op=1
   dbselectarea("ActivProg")
   ActivProg->(dbgotop())
   DEFINE DIALOG oDlgu FROM 17, 35 TO 30, 78 ;
   TITLE "Actividades del Proyecto"
   DEFINE FONT oFontu NAME "Arial" SIZE 5,12  BOLD

   @ 0.2,0 GET otemp VAR utemp ;
           SIZE 50, 9 ;
           OF oDlgu;
           FONT oFontu PICTURE "@!" ;
             ON CHANGE ( Olbx:Assign(),;
                       if(nRecno>=VAL( Substr(uTemp,1, Olbx:npos-1 )+;
                       if(olbx:tamayo>47 .and. olbx:tamayo<58, Upper( Chr( olbx:tamayo ) ),'') ) .and. ;
                       VAL( Substr(uTemp,1, Olbx:npos-1 )+;
                       if(olbx:tamayo>47 .and. olbx:tamayo<58, Upper( Chr( olbx:tamayo ) ),'') ) >  0   , ; 
                       ( ActivProg->(dbgoto(VAL(Substr(uTemp,1, Olbx:npos-1 )+;
                         if(olbx:tamayo>47 .and. olbx:tamayo<58, Upper( Chr( olbx:tamayo ) ),'') ) ) ) ,;
                         oLbxu:UpStable(), oLbxu:Refresh(), .t. ),;
                        ( oLbxu:UpStable(), oLbxu:Refresh(), .f. ) ) )

   @ 0.9, 0 LISTBOX oLbxu ;
      FIELDS xPadl(str(ActivProg->Correl,4,0),25),;
      ActivProg->descri;
      COLOR CLR_BLACK, RGB(255,255,235);
      HEADERS  OemToAnsi("Item" ),OemToAnsi( "Descripcin");
      FIELDSIZES 25, 235;
      ON DBLCLICK ( if(fvitem(ActivProg->correl,wCorrel,opt),;
                    (lsave:=.T. ,odlgu:end() ) ,;
                     lsave:=.F. ) );
      SIZE 172, 87.5 ;
      FONT oFontu OF oDlgu
      oLbxu:nStyle:=nOR(WS_CHILD,WS_VSCROLL,WS_BORDER,WS_VISIBLE,WS_TABSTOP,0)

      @ 0.12,23 BUTTON "&Aceptar"    OF oDlgu ;
         ACTION ( if(fvitem(ActivProg->correl,wCorrel,opt),;
                    (lsave:=.T. ,odlgu:end() ) ,;
                     lsave:=.F. ) ); 
           SIZE 25, 9 FONT Ofontu

      @ 0.12,29 BUTTON "&Cancelar"   OF oDlgu ;
           ACTION oDlgu:End()         SIZE 25, 9 FONT oFontu

     ACTIVATE DIALOG oDlgu

  if lsave
    if opt
       if !valPres(wCorrel,ActivProg->Correl)
          ActivProg->(dbgoto(Oldrec))
          Return NIL
       endif
       PresGan->(dbappend())
       PresGan->Correl:=wCorrel
       PresGan->Item:=wItem
       PresGan->CorPre:=ActivProg->Correl
       PresGan->ItePre:=ActivProg->Item
       PresGan->DesPre:=ActivProg->Descri
       PresGan->(dbcommit())
       dbselectarea('PresGan')
       oLbx0:setfilter( 'str(Correl,4,0)',str(wCorrel,4,0),str(wCorrel,4,0) )
       oLbx0:gotop()
       oLbx0:UpStable()
       oLbx0:refresh(.T.)  
    else
      witem:=ActivProg->Item
    endif
  endif
case op=2
   PresGan->(rlock())
   PresGan->(dbdelete())
   PresGan->(dbcommit())
   oLbx0:setfilter( 'str(Correl,4,0)',str(wCorrel,4,0),str(wCorrel,4,0) )
   if !(PresGan->(dbseek(str(wCorrel,4,0))))
          olbx0:BLogicLen = { || 0}
          olbx0:refresh(.T.)
   else
          olbx0:gotop()
          olbx0:UpStable()
          olbx0:refresh(.T.)
   endif
case op=3
   if PresGan->(DBseek(str(ActivProg->Correl,4,0)))
      if msgNoYes(OemToAnsi("Desa elminar todas las Actividades precedentes,")+CRLF+OemToAnsi("Si Continuna..., se eleminarn las precedencia"),OemtoANsi("Atencin"))
         do while PresGan->Correl = ActivProg->Correl .and. PresGan->(!eof())
            Presgan->(Rlock())
            PresGan->(dbdelete())
            Presgan->(dbunlock())
            Presgan->(dbskip())
          enddo
          oLbx0:setfilter( 'str(Correl,4,0)',str(wCorrel,4,0),str(wCorrel,4,0) )
          if !(PresGan->(dbseek(str(wCorrel,4,0))))
             olbx0:BLogicLen = { || 0}
             olbx0:refresh(.T.)
          else
             olbx0:gotop()
             olbx0:UpStable()
             olbx0:refresh(.T.)
          endif
       endif
    endif
endcase
ActivProg->(dbgoto(Oldrec))
return NIL

//--------------------------------------------------//
Function CalGantt(wdialab,dFecIni,dfecAnt,op,VerPres)

Local nOldrec:=ActivProg->(Recno()),nDiaCam,wOldrec
local Nrec:=0,cFecFin,ndia:=0,i:=0,wcorpre:=0
local ruta:={},Cami:={},wCorrel,NueCor:=0,j:=0,wDiaTot:=0,sw:=.T.
local wfecPri:=ctod('  /  /  ')
local cfecIni:=ctod('  /  /  ')
CursorWait()
if !empty(dFecAnt)
  nDiaCam:=dFecIni-dfecAnt
endif
ActivProg->(dbgotop())
do while ActivProg->(!eof())
   ActivProg->ItePre:=0
    cFecIni:=dfecini
   if empty(ActivProg->Fecini)
      ActivProg->(rlock())
      ActivProg->FecIni:=dFecIni
      ActivProg->(dbUnlock())
   endif
   if PresGan->(DBseek(STR(ActivProg->Correl,4,0))) 
      cFecIni:=dfecini
      nrec:=ActivProg->(recno())
      do while PresGan->Correl = ActivProg->Correl .and. PresGan->(!eof())
         ActivProg->(dbgoto(PresGan->CorPre))
         if cfecIni<=ActivProg->FecFin
            cFecIni:=ActivProg->FecFin+1
            wCorpre:=Presgan->Corpre
         endif
         ActivProg->(dbgoto(nrec))
         PresGan->(dbskip())
      enddo
      ActivProg->(dbgoto(nrec))
       do while !wDiaLab[Dow(cFecIni)]
          cFecIni++
       enddo
       ActivProg->(rlock())
       ActivProg->FecIni:=cFecIni
       ActivProg->Itepre:=wCorpre
       ActivProg->(dbUnlock())
   else
     if Op .and. dFecAnt!=dfecIni
        cFecIni:=ActivProg->FecIni+ndiaCam
        do while !wDiaLab[Dow(cFecIni)]
           cFecIni++
        enddo
        ActivProg->(rlock())
        ActivProg->FecIni:=cFecIni
        ActivProg->(dbUnlock())
     endif
   endif
   If ActivProg->diapro - Int(ActivProg->Diapro) > 0
      ndia:=Int(ActivProg->diapro)
   else
      ndia:=Int(ActivProg->diapro)-1
   endif
   cFecFin:=ActivProg->fecIni
   for i=1 to ndia
       cFecFin++ 
       do while !wDiaLab[Dow(cFecFin)]
          cFecFin++
       enddo
   next
   ActivProg->(rlock())
   ActivProg->FecFin:=cFecFin
   ActivProg->(dbUnlock())
   ActivProg->(dbskip())
enddo
/**critico************************************/
         i:=0
         ActivProg->(dbgotop())
         do while ActivProg->(!eof())
            wOldrec:=ActivProg->(recno())
            ActivProg->(rlock())
            ActivProg->TipAct:=0
            ActivProg->(dbunlock())
            if ActivProg->ItePre>0
               i++
               sw:=.t.
               wDiatot:=0
               wDiaTot:=(ActivProg->FecFin-ActivProg->fecIni+1) //ojo
               wCorrel:=ActivProg->Correl
               wCorPre:=ActivProg->ItePre
               AADD(Cami,{i,wCorrel})
               wFecpri:=ActivProg->FecIni
               ActivProg->( dbgoto(wCorpre) )
               do while ActivProg->(!eof()) .and. sw
                  wDiaTot:=wDIaTot+(wFecPri-ActivProg->fecIni)
                  wcORPRE:=ActivProg->ItePre
                  wCorrel:=ActivProg->Correl
                  if VerPres
                     if ASCAN(Cami, {|x| x[2] = wcorrel .and. x[1]=i }) !=0
                         MsgInfo("Exite redundancia en el vnculo del Item "+Alltrim(str(wCorrel))+" Con el item precedente "+AllTrim(str(wCorPre))+CRLF+;
                                 OemToAnsi("El sistema eliminar este vnculo...!")+CRLF+CRLF+"Por Favor Refresque el Cronograma para Recalcular Tiempos...","Error Grave" )
                         if presgan->(dbseek(str(wCorrel,4,0)+str(wCorpre) ) )
                           Presgan->(rlock())
                           Presgan->(dbdelete())
                           Presgan->(dbunlock())
                         endif
                         ActivProg->(dbgoto(nOldrec))
                         CursorArrow()
                         Return NIL
                     endif
                  endif
                  AADD(Cami,{i,wCorrel})
                  if wCorpre > 0
                     wFecpri:=ActivProg->FecIni
                     ActivProg->(Dbgoto(wCorPre))
                  else
                     sw:=.f.
                  endif
               enddo
               AADD(Ruta,{i,WDiaTot})
           endif
           ActivProg->(dbgoto(wOldrec))
           ActivProg->(dbskip())
         enddo
         wDiatot:=0
         for j=1 to len(ruta)
             if ruta[j][2] > wDiatot
                wDiatot:=ruta[j][2]
                  Nuecor:=j
             endif
         next
         if wDiatot>0
            for j=1 to Len(cami)
                if cami[j][1]=Nuecor
                   ActivProg->(dbgoto(cami[j][2]))
                   ActivProg->(rlock())
                   ActivProg->TipAct:=1
                   ActivProg->(dbUnlock())
                endif
            next
         endif
ActivProg->(dbgoto(nOldrec))
CursorArrow()
dFecAnt:=dFecIni
dbcommitall()
Return NIL
//-------------------------------------------------//
Static Function editPre(odias,ofont,nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,nTipo,nvertic,olbx,wDiaLab) 
Local wCorPre,wCorrel,wItem,wItepre,wDesPre
Local noldrec:=ActivProg->(recno())
 wCorPre:=oGraficos:nItem
 wCorrel:=oGraficos:nItePre
if wCorrel=wCorPre
   Return NIL
endif
if wCorrel > 0 .and. wCorPre > 0
   ActivProg->(dbgoto(wCorrel))
   wItem:=ActivProg->Item
   ActivProg->(dbgoto(wCorPre))
   wItepre:=ActivProg->Item
   wDesPre:=ActivProg->Descri
   ActivProg->(dbgoto(nOldrec))
   if Presgan->(dbseek(str(wCorrel,4,0)+str(wCorPre,4,0) ) )
     MsgInfo(OemtoAnsi("La Viculacin de Actividades ya se efectuo"),OemToAnsi("Atencin"))
   else
     if  ValPres(wCorrel,wCorpre)
         Presgan->(dbappend())
         PresGan->Correl:=wCorrel
         PresGan->CorPre:=wCorPre
         PresGan->Item:=wItem
         PresGan->ItePre:=wItePre
         PresGan->DesPre:=wDesPre
         Presgan->(dbunlock())
         CalGantt(wdialab,@dFecIni,,.f.,.t.)
         olbx:refresh()
         oGraficos:refresh()
     endif
   endif
endif
Return NIL
//------------------------------------------------//
Static Function editFec(odias,ofont,nHoriz,osplit,ograficos,oSplit1,oPen1,oPen3,oPen4,oPen5,oPen2,dFecIni,dFecha,nTipo,nvertic,olbx,wDiaLab) 
Local nOldRec:= ActivProg->(RecNO())
Local wfecIni,wfecFin,wDiapro,ndias:=0,i:=0
local ncol1:=Ograficos:nCol1
local ncol2:=Ograficos:nCol2
Local Lsave:=.f.
Local wIniAnt
ActivProg->(dbgoto(oGraficos:nitem))

wIniAnt := ActivProg->FecIni
wfecIni := ActivProg->FecIni
wfecFin := ActivProg->FecFin

if oGraficos:nLCol .and. !oGraficos:nRcol //cuando se mueve a la izquierda
   do case
      case ntipo=1
         wFecIni:=dfecha+ROUND( (nCol1-nhoriz)/14,0 )
      case ntipo=2
         wFecIni:=dfecha+ROUND( (nCol1-nhoriz)/8,0 )
      case ntipo=3
         wFecIni:=dfecha+ROUND( (nCol1-nhoriz)/2 ,0)
   Endcase
   do while !wDiaLab[Dow(wFecIni)]
      wFecIni++
   enddo
  lsave:=.t.
elseif ograficos:nRcol .and. !oGraficos:nLCol //cuando se mueve a la derecha
   do case
      case ntipo=1
         wFecFin:=dfecha+ROUND( (nCol2-nhoriz)/14 ,0 ) -1
      case ntipo=2
         wFecFin:=dfecha+ROUND( (nCol2-nhoriz)/8 ,0) -1
      case ntipo=3
         wFecFin:=dfecha+ROUND( (nCol2-nhoriz)/2 , 0 ) -1
   Endcase
   do while !wDiaLab[Dow(wFecFin)]
      wFecFin--
   enddo
  lsave:=.t.
elseif ograficos:nRcol .AND. ograficos:nlcol //mueve barra completa
   wdiapro := ActivProg->diapro
   do case
      case ntipo=1
         wFecIni:=dfecha+ROUND( (nCol1-nhoriz)/14,0 )
      case ntipo=2
         wFecIni:=dfecha+ROUND( (nCol1-nhoriz)/8,0 )
      case ntipo=3
         wFecIni:=dfecha+ROUND( (nCol1-nhoriz)/2 ,0)
   Endcase
   do while !wDiaLab[Dow(wFecIni)]
      wFecIni++
   enddo
   lsave:=.f.
endif
if LSave
  wdiapro:=1
  ndias:=wFecFin-wfecIni
  for i=1 to ndias
    if wDiaLab[Dow(wFecIni+i)]
       wDiapro++
    endif
  NEXT
else
  wfecFin:=wFecIni-1
  i:=0
  do while i <= wdiapro
    wfecFin++
    if wDiaLab[Dow(wFecIni+i)]
       wFecFin++
    endif
    i++
  enddo
endif
  if wIniant != wFecIni
     if PresGan->(DBseek(str(ActivProg->Correl,4,0)))
        if msgNoYes(OemToAnsi("El Item tiene Actividades precedentes,")+CRLF+OemToAnsi("Si Continuna..., se eleminarn las precedencia"),OemtoANsi("Atencin"))
           do while PresGan->Correl = ActivProg->Correl .and. PresGan->(!eof())
              Presgan->(Rlock())
              PresGan->(dbdelete())
              Presgan->(dbunlock())
              Presgan->(dbskip())
           enddo
        else
          ActivProg->(dbgoto(nOldrec))
          Return NIL
        endif
     endif
  endif
  if wfecIni < dFecIni
     MsgInfo("La fecha No puede ser menor a la fecha de inicio definida en el proyecto",OemToANsi("Atencin") )
     ActivProg->(dbgoto(nOldrec))
     Return NIL
  endif
  ActivProg->(Rlock())
  ActivProg->Fecini:=wfecini
  ActivProg->FecFin:=wFecFin
  ActivProg->DiaPro:=wDiapro
  ActivProg->(dbunlock())
  CalGantt(wdialab,@dFecIni,,.f.,.f.)
  olbx:refresh()
  oGraficos:refresh()
  ActivProg->(dbgoto(nOldrec))
Return NIL

//----------------------------------------------------------------//
Static function fvitem(wCorPre,wCorrel,op)
local oldrec
    if wcorrel=wCorpre
       if op
          oldrec:=PresGan->(recno())
          nMsgbox(Oemtoansi('No es posible asignar la misma actividad como precedente'),OemtoAnsi('Error'))
          PresGan->(dbgoto(oldrec))
       else
         nMsgbox(Oemtoansi('No es posible asignar la misma actividad para copiar'),OemtoAnsi('Error'))
       endif
       return .f.
    endif
if op
   oldrec:=PresGan->(recno())
    if PresGan->(dbseek(str(wCorrel,4,0)+str(wCorpre,4,0)))
       nMsgbox(Oemtoansi('La actividad ya se encuentra asignada como precedente'),OemtoAnsi('Error'))
       PresGan->(dbgoto(oldrec))
       return .f.
    endif
    PresGan->(dbgoto(oldrec))
endif
return .t.
//-----------------------------//
Static Function ValPres(wCorrel,wCorpre)
local wcorMio:=wCorPre, sw :=.t.,oldrec
if Presgan->(dbseek(str(wCorMio,4,0) ) )
   do while Presgan->(!eof())
      oldrec:=Presgan->(recno())
      if Presgan->Correl=wCorpre
         Do while  sw 
            if Presgan->(dbseek(str(wCorMio,4,0) ) )
               wCorMio:=PresGan->corpre
               if wCormio=wCorrel
                  nMsgbox(Oemtoansi('Existe redundancia en la vinculacin..., no es posible su vinculacin'),OemtoAnsi('Error'))
                  return .f.
               endif
            else
               sw:=.f.
            endif
         enddo
      endif
      Presgan->(dbgoto(Oldrec))
      Presgan->(dbskip())
   enddo
endif
Return .t.
//-------------------------------------------------------------------//
Function aFlecha(wCorcri,oPen6,oPen7,oGraficos,nVertic,nHoriz,nColumnaInicio,dfecha,n)

local nOldrec,i:=0,h:=0,j:=0

              if PresGan->(DBseek(str(ActivProg->Correl,4,0)))
                 h:=0
                 do while PresGan->Correl = ActivProg->Correl
                    noldrec:=ActivProg->(recno())
                    ActivProg->(dbgoto(PresGan->CorPre))
                    if ActivProg->Correl=wCorCri
                       if PresGan->Correl > PresGan->Corpre
                          oGraficos:Line( (PresGan->CorPre-1)*14+nVertic+7, (ActivProg->fecFin-dFecha+1)*n+nHoriz,(PresGan->CorPre-1)*14+nvertic+7 , nColumnaInicio+nHoriz+5+10*h,oPen7  )
                          ActivProg->(dbgoto(nOldrec))
                          oGraficos:Line( (PresGan->CorPre-1)*14+nVertic+7, nColumnaInicio+nHoriz+5+10*h,(PresGan->Correl-1)*14+nvertic+5 , nColumnaInicio+nHoriz+5+10*h,oPen7  ) //vertical
                          i:=0
                          For i:=1 to 5
                             oGraficos:Line( ((ActivProg->Correl-1)*14)+nVertic, nColumnaInicio+nHoriz+i+10*h,((ActivProg->Correl-1)*14)+nvertic+i , nColumnaInicio+nHoriz+i+10*h,oPen7  )
                          next
                          i:=0
                          For i:=1 to 5
                              oGraficos:Line( ((ActivProg->Correl-1)*14)+nVertic, nColumnaInicio+nHoriz+5+i+10*h,((ActivProg->Correl-1)*14)+nvertic+5-i , nColumnaInicio+nHoriz+5+i+10*h,oPen7  )
                          next
                          h++
                       else
                          oGraficos:Line( (PresGan->CorPre-1)*14+nVertic+7, (ActivProg->fecFin-dFecha+1)*n+nHoriz,(PresGan->CorPre-1)*14+nvertic+7 , nColumnaInicio+nHoriz+5+10*j,oPen7  )
                          ActivProg->(dbgoto(nOldrec))
                          oGraficos:Line( (PresGan->CorPre-1)*14+nVertic+7, nColumnaInicio+nHoriz+5+10*j,(PresGan->Correl-1)*14+nvertic+5 , nColumnaInicio+nHoriz+5+10*j,oPen7  )
                          i:=0
                          For i:=1 to 5
                              oGraficos:Line( ((ActivProg->Correl-1)*14)+nVertic+9+5-i, nColumnaInicio+nHoriz+i+10*j,((ActivProg->Correl-1)*14)+nvertic+9+5 , nColumnaInicio+nHoriz+i+10*j,oPen7  )
                          next
                          i:=0
                          For i:=1 to 5
                              oGraficos:Line( ((ActivProg->Correl-1)*14)+nVertic+9+i, nColumnaInicio+nHoriz+5+i+10*j,((ActivProg->Correl-1)*14)+nvertic+9+5 , nColumnaInicio+nHoriz+5+i+10*j,oPen7  )
                          next
                          j++
                       endif
                    else
                       if PresGan->Correl > PresGan->Corpre
                          oGraficos:Line( (PresGan->CorPre-1)*14+nVertic+7, (ActivProg->fecFin-dFecha+1)*n+nHoriz,(PresGan->CorPre-1)*14+nvertic+7 , nColumnaInicio+nHoriz+5+10*h,oPen6  )
                          ActivProg->(dbgoto(nOldrec))
                          oGraficos:Line( (PresGan->CorPre-1)*14+nVertic+7, nColumnaInicio+nHoriz+5+10*h,(PresGan->Correl-1)*14+nvertic+5 , nColumnaInicio+nHoriz+5+10*h,oPen6  )
                          i:=0
                          For i:=1 to 5
                             oGraficos:Line( ((ActivProg->Correl-1)*14)+nVertic, nColumnaInicio+nHoriz+i+10*h,((ActivProg->Correl-1)*14)+nvertic+i , nColumnaInicio+nHoriz+i+10*h,oPen6  )
                          next
                          i:=0
                          For i:=1 to 5
                              oGraficos:Line( ((ActivProg->Correl-1)*14)+nVertic, nColumnaInicio+nHoriz+5+i+10*h,((ActivProg->Correl-1)*14)+nvertic+5-i , nColumnaInicio+nHoriz+5+i+10*h,oPen6  )
                          next
                          h++
                       else
                          oGraficos:Line( (PresGan->CorPre-1)*14+nVertic+7, (ActivProg->fecFin-dFecha+1)*n+nHoriz,(PresGan->CorPre-1)*14+nvertic+7 , nColumnaInicio+nHoriz+5+10*j,oPen6  )
                          ActivProg->(dbgoto(nOldrec))
                          oGraficos:Line( (PresGan->CorPre-1)*14+nVertic+7, nColumnaInicio+nHoriz+5+10*j,(PresGan->Correl-1)*14+nvertic+9 , nColumnaInicio+nHoriz+5+10*j,oPen6  )
                          i:=0
                          For i:=1 to 5
                              oGraficos:Line( ((ActivProg->Correl-1)*14)+nVertic+9+5-i, nColumnaInicio+nHoriz+i+10*j,((ActivProg->Correl-1)*14)+nvertic+9+5 , nColumnaInicio+nHoriz+i+10*j,oPen6  )
                          next
                          i:=0
                          For i:=1 to 5
                              oGraficos:Line( ((ActivProg->Correl-1)*14)+nVertic+9+i, nColumnaInicio+nHoriz+5+i+10*j,((ActivProg->Correl-1)*14)+nvertic+9+5 , nColumnaInicio+nHoriz+5+i+10*j,oPen6  )
                          next
                          j++
                       endif
                    endif
                    PresGan->(dbskip())
                 enddo
 
              endif
Return NIL
