//----------------------------------------------------------------------------//
// GANTT

#xcommand @ <nRow>, <nCol> GANTT [<oGantt>] ;
             [ <dlg: OF, WINDOW, DIALOG> <oWnd> ] ;
             [ SIZE <nWidth>, <nHeight> ] ;
             [ <border: BORDER>] ;
             [ <vScroll: VSCROLL, VERTICAL SCROLL> ] ;
             [ <hScroll: HSCROLL, HORIZONTAL SCROLL> ] ;
             [ <color: COLOR, COLORS> <nClrFore> [,<nClrBack>] ] ;
             [  ON CHANGE <uChange> ] ;
             [  ON PRESED <uPresed> ] ;
             [  BOXLIS <uLbx> ] ;
       => ;
          [<oGantt> := ] TGantt():New( <nRow>, <nCol>, <nWidth>, <nHeight>, <oWnd>,;
             <.border.>, [<.vScroll.>], [<.hScroll.>], <nClrFore>,;
             <nClrBack>,[<{uChange}>],[<{uPresed}>],<uLbx> )

#xcommand REDEFINE GANTT [<oGantt>] ;
             [ ID <nId> ] ;
             [ <dlg: OF, WINDOW, DIALOG> <oWnd> ] ;
             [ <color: COLOR, COLORS> <nClrFore> [,<nClrBack>] ] ;
       => ;
          [ <oGantt> := ] TGantt():Redefine( <nId>, <oWnd>,;
             <nClrFore>, <nClrBack> )
